/**
 * Created by Largoyle on 12/04/2014.
 */

/// <reference path="H:/Webpages/96ideas/Gamster/root/libs/phaser/build/phaser.d.ts" />

module BTSLD29 {

    export class Boot extends Phaser.State {

        preload() {

            this.load.image('preloadBar', 'assets/std/img/bts_loadingbar2.png');
            this.load.image('logo', 'assets/i96_logo.png');
            this.game.stage.backgroundColor = '#ffffff';

        }

        create() {

            //  Unless you specifically need to support multitouch I would recommend setting this to 1
            this.input.maxPointers = 1;

            //  Phaser will automatically pause if the browser tab the game is in loses focus. You can disable that here:
            this.stage.disableVisibilityChange = true;

            if (this.game.device.desktop) {
                //  If you have any desktop specific settings, they can go in here
//                this.stage.scale.pageAlignHorizontally = true;
            }
            else {
                //  Same goes for mobile settings.
                //  In this case we're saying "scale the game, no lower than 480x260 and no higher than 1024x768"
//                this.stage.scaleMode = Phaser.StageScaleMode.SHOW_ALL;
//                this.stage.scale.minWidth = 480;
//                this.stage.scale.minHeight = 260;
//                this.stage.scale.maxWidth = 1024;
//                this.stage.scale.maxHeight = 768;
//                this.stage.scale.forceLandscape = true;
//                this.stage.scale.pageAlignHorizontally = true;
//                this.stage.scale.setScreenSize(true);
            }

            this.game.state.start('Preloader', true, false);

        }

    }

}
