/**
 * Created by Largoyle on 12/04/2014.
 */

/// <reference path="H:/Webpages/96ideas/Gamster/root/libs/phaser/build/phaser.d.ts" />
/// <reference path="./Player.ts" />

module BTSLD29 {

    export class Level1 extends Phaser.State {

        background: Phaser.Sprite;
        music: Phaser.Sound;
        player: BTSLD29.Player;
        tiledata_old = [
            ['30', '30', '30', '255', '57', '57', '57', '255', '44', '44', '44', '255', '44', '44', '44', '255', '57', '57', '57', '255', ],
            ['57', '57', '57', '255', '100', '100', '100', '255', '84', '84', '84', '255', '70', '70', '70', '255', '57', '57', '57', '255', ],
            ['57', '57', '57', '255', '30', '30', '30', '255', '44', '44', '44', '255', '70', '70', '70', '255', '100', '100', '100', '255', ],
            ['84', '84', '84', '255', '57', '57', '57', '255', '44', '44', '44', '255', '57', '57', '57', '255', '30', '30', '30', '255', ],
            ['100', '100', '100', '255', '84', '84', '84', '255', '57', '57', '57', '255', '57', '57', '57', '255', '57', '57', '57', '255', ],
            ['70', '70', '70', '255', '70', '70', '70', '255', '70', '70', '70', '255', '70', '70', '70', '255', '44', '44', '44', '255', ],
            ['57', '57', '57', '255', '57', '57', '57', '255', '70', '70', '70', '255', '84', '84', '84', '255', '120', '120', '120', '255', ],
            ['120', '120', '120', '255', '84', '84', '84', '255', '84', '84', '84', '255', '44', '44', '44', '255', '84', '84', '84', '255', ],
            ['120', '120', '120', '255', '100', '100', '100', '255', '100', '100', '100', '255', '84', '84', '84', '255', '84', '84', '84', '255', ],
            ['70', '70', '70', '255', '84', '84', '84', '255', '100', '100', '100', '255', '148', '148', '148', '255', '120', '120', '120', '255', ],
            ['84', '84', '84', '255', '57', '57', '57', '255', '44', '44', '44', '255', '57', '57', '57', '255', '44', '44', '44', '255', ],
        ];
        colordata = ['00a8ff', '43ae3f', '83c84e', 'bedd60', 'f1ea69', 'f4d757', 'f0b449', 'e6843b', 'ce553f', 'a7828e', 'd6d1d9'];

        // tiledata: [ '7', '6', '3', '2', '1', '1', '1', '1', '1', '1', '1', '1', '1', '2', '2', '2', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '2', '2', '2', '2', '2', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '6', '6', '3', '2', '1', '1', '1', '1', '1', '1', '1', '1', '2', '2', '2', '2', '2', '2', '1', '1', '1', '1', '1', '1', '2', '2', '2', '2', '2', '2', '2', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '3', '3', '2', '1', '1', '1', '1', '1', '1', '1', '2', '2', '2', '3', '3', '3', '3', '3', '2', '1', '1', '1', '1', '2', '2', '2', '2', '2', '2', '2', '2', '2', '2', '2', '2', '2', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '6', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '2', '2', '1', '1', '1', '1', '1', '1', '1', '1', '2', '2', '3', '11', '11', '5', '3', '3', '2', '1', '1', '1', '1', '2', '2', '2', '2', '2', '2', '2', '3', '3', '3', '3', '3', '2', '2', '2', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '6', '10', '6', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '2', '2', '3', '9', '10', '5', '3', '3', '2', '1', '1', '1', '1', '2', '2', '2', '2', '2', '2', '2', '3', '5', '11', '11', '5', '3', '3', '2', '2', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '6', '10', '10', '6', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '3', '3', '3', '3', '3', '3', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '2', '2', '3', '8', '6', '5', '3', '2', '2', '1', '1', '1', '1', '2', '2', '2', '2', '2', '2', '2', '3', '3', '3', '3', '3', '2', '2', '2', '2', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '6', '10', '10', '6', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '3', '3', '3', '5', '5', '5', '5', '3', '3', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '2', '2', '3', '3', '3', '3', '2', '2', '2', '1', '1', '1', '1', '2', '2', '2', '2', '2', '2', '2', '2', '2', '2', '2', '2', '2', '2', '2', '2', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '6', '10', '10', '6', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '3', '3', '3', '5', '5', '5', '5', '3', '3', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '2', '2', '3', '3', '3', '2', '2', '2', '1', '1', '1', '1', '2', '2', '2', '2', '2', '2', '2', '2', '2', '2', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '6', '6', '6', '6', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '3', '3', '3', '3', '3', '3', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '2', '2', '2', '2', '2', '2', '1', '1', '1', '1', '1', '2', '2', '2', '2', '2', '2', '2', '2', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '2', '2', '2', '2', '2', '2', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '2', '2', '2', '2', '2', '2', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1'];
        playerspeed = 200;
        tiledata = [ 7, 6, 3, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 6, 6, 3, 2, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 3, 2, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 3, 3, 3, 3, 3, 2, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 6, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 3, 11, 11, 5, 3, 3, 2, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 6, 10, 6, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 3, 9, 10, 5, 3, 3, 2, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 3, 5, 11, 11, 5, 3, 3, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 6, 10, 10, 6, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 3, 3, 3, 3, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 3, 8, 6, 5, 3, 2, 2, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 6, 10, 10, 6, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 3, 3, 5, 5, 5, 5, 3, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 3, 3, 3, 3, 2, 2, 2, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 6, 10, 10, 6, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 3, 3, 5, 5, 5, 5, 3, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 3, 3, 3, 2, 2, 2, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 6, 6, 6, 6, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 3, 3, 3, 3, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1];
        tiledata_width = 80;
        tiledata_height = 11;

        level_tiles;
        level_bodies;
        level_sprites;

        leveldata : {
            tiles: number[][]
            sprites: Phaser.Sprite[][]
        };
//            = {
//            tiles = [],
//            sprites= []
//        }
        call = {
//            hasStarted: <bool> null,
//            hasFinished: <bool> null,
            id: <number> null
        };
        lvlgroup;
        tile_width = 40;
        tile_height = 40;
        slopeMap = [ 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ];
        cursors;
        layer;
        layerA;
        layerAdata;
        layerB;
        layerBdata;
        map;
        sirwalter: Phaser.Sprite;
        ninjatiles;

        level : number;

        preload() {

            // load tiles as spritesheet
            this.game.load.spritesheet('lvl1_tiles', 'assets/std/img/bts_lvl_tiles.png', 40, 40, 11);

            this.game.stage.backgroundColor = '#00a8ff';
        }

        create() {


            // init leveldata
            // TODO: how to do that in the declaration
//            this.leveldata = {
//               tiles:  new Array(),
//               sprites: [[null],[null]]
//            };

            // this.leveldata["tiles"] = [];

            this.game.physics.startSystem(Phaser.Physics.ARCADE);

            this._createLevel();

            // player
            this.sirwalter = this.game.add.sprite(200, 100, 'sirwalter');

            // add body to player
            this.game.physics.enable(this.sirwalter, Phaser.Physics.ARCADE);

            this.game.camera.follow(this.sirwalter);
            this.cursors = this.game.input.keyboard.createCursorKeys();

            }

        _createLevel() {

            this.lvlgroup = this.game.add.group();
            this.lvlgroup.enableBody = true;
            this.lvlgroup.physicsBodyType = Phaser.Physics.ARCADE;

//            for (var i = 0; i < 50; i++)
//            {
//                var c = group.create(
//                    game.rnd.integerInRange(100, 770),
//                    game.rnd.integerInRange(0, 570),
//                    'veggies',
//                    game.rnd.integerInRange(0, 35));
//                c.name = 'veg' + i;
//                c.body.immovable = true;
//            }
//
//            for (var i = 0; i < 20; i++)
//            {
//                //  Here we'll create some chillis which the player can pick-up. They are still part of the same Group.
//                var c = group.create(game.rnd.integerInRange(100, 770), game.rnd.integerInRange(0, 570), 'veggies', 17);
//                c.name = 'chilli' + i;
//                c.body.immovable = true;
//            }


            for (var y=0; y<this.tiledata_width; y++) {
                for (var x=0; x<this.tiledata_width; x++) {

                    this.level_tiles[y][x] = this.tiledata[y*this.tiledata_width+x];

                    if (this.leveldata["tiles"][y][x] != 1) {

                        this.leveldata["sprites"][y][x] = this.game.add.sprite(x * this.tile_width, y * this.tile_height, 'lvl1_tiles', this.tiledata[y * this.tiledata_width + x] - 1);

                        this.lvlgroup.add(this.leveldata["sprites"][y][x]);

                        this.leveldata["sprites"][y][x].body.immovable = true;
                    }
                    this.leveldata["sprites"][y][x] = null;
                }
            }

            this.game.world.setBounds(0, 0, this.tiledata_width*this.tile_width, this.tiledata_height*this.tile_height);
        }

        // hide all tiles with an index lower than level
        _setWaterLevel(level: number) {

            for (var y=0; y<this.tiledata_width; y++) {
                for (var x = 0; x < this.tiledata_width; x++) {
                    // is is below the surface?
                    if (this.leveldata["tiles"][y][x] < level) {
                        this.leveldata["sprites"][y][x];
                    }
                }
            }

        }


        update() {

//            for (var i = 0; i < this.ninjatiles.length; i++) {
//                this.sirwalter.body.circle.collideCircleVsTile(this.ninjatiles[i].tile);
//            }

            this.game.physics.arcade.collide(this.sirwalter, this.lvlgroup, null, null, this);

            if (this.cursors.left.isDown) {
                this.sirwalter.body.velocity.x = -this.playerspeed;
            } else if (this.cursors.right.isDown) {
                this.sirwalter.body.velocity.x = this.playerspeed;
            } else {
                this.sirwalter.body.velocity.x = 0;
            }

            if (this.cursors.up.isDown) {
                this.sirwalter.body.velocity.y = -this.playerspeed;
            } else if (this.cursors.down.isDown) {
                this.sirwalter.body.velocity.y = this.playerspeed;
            } else {
                this.sirwalter.body.velocity.y = 0;
            }

            if (this.level == 1) {
                if (this.game.input.keyboard.isDown(Phaser.Keyboard.SPACEBAR)) {

                    console.log("swap");

//                    this.map = this.game.add.tilemap('testlevel3');          // Load tilemap
//                    this.map.addTilesetImage('Test', 'testtiles');          // add the tile images
//                    this.layer = this.map.createLayer('Tile Layer 1');      // create layer from tilemap
//                    this.layer.alpha = 0;
//
//                    this.sirwalter.bringToTop();
//
//                    // this.add.tween(this.layer).to({ alpha: 1 }, 1500, Phaser.Easing.Elastic.Out, true);
//                    this.add.tween(this.layer).to({ alpha: 1 }, 800, Phaser.Easing.Linear.None, true);

                    this.level++;
                }
            }
        }

        render() {

        }
    }

}
